"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MongooseSchemaService = void 0;
var mongoose_1 = __importDefault(require("mongoose"));
var MongooseSchemaService = /** @class */ (function () {
    function MongooseSchemaService() {
    }
    ;
    MongooseSchemaService.getInstance = function () {
        if (!MongooseSchemaService._instance)
            MongooseSchemaService._instance = new MongooseSchemaService();
        return MongooseSchemaService._instance;
    };
    ;
    MongooseSchemaService.prototype.transformData = function () {
        return {
            toJSON: {
                transform: function (doc, ret) {
                    var id = doc._id;
                    ret.id = id;
                    delete ret._id;
                    delete ret.__v;
                },
            },
            timestamps: {
                createdAt: 'creationDate',
                updatedAt: 'lastModifiedDate',
            }
        };
    };
    ;
    MongooseSchemaService.prototype.genDocId = function () {
        return new mongoose_1.default.Types.ObjectId();
    };
    MongooseSchemaService.prototype.createdByAndUpdatedBySave = function (next) {
        try {
            var locals = this.get('locals');
            if (!locals)
                throw { error: new Error("locals is required field for createdByAndUpdatedBySave mongoose middleware fn") };
            if (!locals.user.id)
                throw { error: new Error("locals.user.id doesn't exist in createdByAndUpdatedBySave mongoose middleware fn") };
            this.set('createdBy', locals.user.id);
            next(undefined);
        }
        catch (error) {
            if (error.error)
                next(error.error);
            next(new Error("Error in createdByAndUpdatedBySave middleware fn , please try again."));
        }
    };
    ;
    MongooseSchemaService.prototype.createdByAndUpdatedByUpdate = function (next) {
        try {
            var locals = this.get('locals');
            if (!locals)
                throw { error: new Error("locals is required field for createdByAndUpdatedByUpdate mongoose middleware fn") };
            if (!locals.user.id)
                throw { error: new Error("locals.user.id doesn't exist in createdByAndUpdatedByUpdate mongoose middleware fn") };
            this.set('createdBy', locals.user.id);
            this.set('updatedBy', locals.user.id);
            next(undefined);
        }
        catch (error) {
            if (error.error)
                next(error.error);
            next(new Error("Error in createdByAndUpdatedByUpdate middleware fn , please try again."));
        }
    };
    ;
    return MongooseSchemaService;
}());
exports.MongooseSchemaService = MongooseSchemaService;
